import AppHeader from "@/components/AppHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import { InputForm } from "@/components/inputForm";
import Styles from "@/constants/Styles";
import { apiCancelTask } from "@/lib/api";
import { setUpdateTask } from "@/lib/taskUpdate";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { router, Stack, useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { SafeAreaView, ScrollView, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

export default function TaskDivisionCancel() {
   const { colors } = useTheme();
   const { id, detail } = useLocalSearchParams<{ id: string; detail: string }>();
   const { token, decryptToken } = useAuthSession();
   const dispatch = useDispatch();
   const update = useSelector((state: any) => state.taskUpdate);
   const [reason, setReason] = useState("");
   const [error, setError] = useState(false);
   const [disable, setDisable] = useState(false);
   const [loading, setLoading] = useState(false)

   function onValidation(val: string) {
      setReason(val);
      if (val == "" || val == "null") {
         setError(true);
      } else {
         setError(false);
      }
   }

   function checkAll() {
      if (reason == "" || reason == "null" || error) {
         setDisable(true);
      } else {
         setDisable(false);
      }
   }

   useEffect(() => {
      checkAll();
   }, [reason, error]);

   async function handleCancel() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current));
         const response = await apiCancelTask(
            {
               reason: reason,
               user: hasil,
            },
            detail
         );
         if (response.success) {
            dispatch(setUpdateTask({ ...update, data: !update.data }));
            Toast.show({ type: 'small', text1: 'Berhasil membatalkan kegiatan', })
            router.back();
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error : any ) {
         console.error(error);
         const message = error?.response?.data?.message || "Gagal membatalkan kegiatan"

         Toast.show({ type: 'small', text1: message })
      } finally {
         setLoading(false)
      }
   }

   return (
      <SafeAreaView style={{ flex: 1, backgroundColor: colors.background }}>
         <Stack.Screen
            options={{
               // headerLeft: () => (
               //    <ButtonBackHeader
               //       onPress={() => {
               //          router.back();
               //       }}
               //    />
               // ),
               headerTitle: "Pembatalan Tugas",
               headerTitleAlign: "center",
               // headerRight: () => (
               //    <ButtonSaveHeader
               //       disable={disable || loading}
               //       category="cancel"
               //       onPress={() => {
               //          handleCancel();
               //       }}
               //    />
               // ),
               header: () => (
                  <AppHeader
                     title="Pembatalan Tugas"
                     showBack={true}
                     onPressLeft={() => router.back()}
                     right={
                        <ButtonSaveHeader
                           disable={disable || loading}
                           category="cancel"
                           onPress={() => {
                              handleCancel();
                           }}
                        />
                     }
                  />
               )
            }}
         />
         <ScrollView>
            <View style={[Styles.p15, Styles.mb100]}>
               <InputForm
                  label="Alasan Pembatalan"
                  type="default"
                  placeholder="Alasan Pembatalan"
                  required
                  bg={colors.card}
                  error={error}
                  errorText="Alasan pembatalan harus diisi"
                  onChange={(val) => onValidation(val)}
               />
            </View>
         </ScrollView>
      </SafeAreaView>
   );
}
